File size: 9,778 Bytes
df0fcce 25cb3f2 df0fcce b3352e3 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 df0fcce be05b16 cd13bae be05b16 df0fcce be05b16 c563853 be05b16 df0fcce 05f02d4 b20ec9e 05f02d4 b20ec9e 05f02d4 4d1a709 05f02d4 53eb639 07b6b93 53eb639 79455e7 df0fcce 25cb3f2 df0fcce |
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 |
#!/bin/bash
pushd `dirname "${BASH_SOURCE[0]}"` >/dev/null
_SCRIPT_DIR=`pwd -P`
popd >/dev/null
function exit_on_error_code {
local _ERR=$?
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--err)
if [[ ${_ERR} -eq 0 ]]
then
_ERR=$1
fi
shift
;;
-h | --help)
if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
then
>&2 echo "Unknown option [${_arg}]"
fi
>&2 echo "Options for ${FUNCNAME[0]} are:"
>&2 echo "[--err INT] use this exit code if '\$?' is 0 (optional)"
>&2 echo "ERROR_MESSAGE error message to print"
exit 1
;;
*) set -- "${_arg}" "$@"; break ;;
esac
done
if [[ ${_ERR} -ne 0 ]]
then
>&2 echo "$(tput setaf 1)ERROR$(tput sgr0): $1: ${_ERR}"
exit ${_ERR}
fi
}
function test_enhanced_getopt {
! getopt --test > /dev/null
if [[ ${PIPESTATUS[0]} -ne 4 ]]
then
>&2 echo "enhanced getopt is not available in this environment"
exit 1
fi
}
function enhanced_getopt {
local _NAME=$0
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--options) local _OPTIONS="$1"; shift ;;
--longoptions) local _LONGOPTIONS="$1"; shift ;;
--name) local _NAME="$1"; shift ;;
--) break ;;
-h | --help | *)
if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
then
>&2 echo "Unknown option [${_arg}]"
fi
>&2 echo "Options for $(basename "$0") are:"
>&2 echo "--options OPTIONS The short (one-character) options to be recognized"
>&2 echo "--longoptions LONGOPTIONS The long (multi-character) options to be recognized"
>&2 echo "--name NAME name that will be used by the getopt routines when it reports errors"
exit 1
;;
esac
done
local _PARSED=`getopt --options="${_OPTIONS}" --longoptions="${_LONGOPTIONS}" --name="${_NAME}" -- "$@"`
if [[ ${PIPESTATUS[0]} -ne 0 ]]
then
exit 2
fi
echo "${_PARSED}"
}
function init_conda_env {
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--name) local _name="$1"; shift
echo "name = [${_name}]"
;;
--prefix) local _prefixroot="$1"; shift
echo "prefix = [${_prefixroot}]"
;;
--tmp) local _prefixroot="$1"; shift
>&2 echo "Deprecated --tmp option. Use --prefix instead."
echo "tmp = [${_prefixroot}]"
;;
--) break ;;
-h | --help | *)
if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
then
>&2 echo "Unknown option [${_arg}]"
fi
>&2 echo "Options for ${FUNCNAME[0]} are:"
>&2 echo "--name STR conda env prefix name"
>&2 echo "--prefix DIR directory to hold the conda prefix"
exit 1
;;
esac
done
local _CONDA_ENV=$CONDA_DEFAULT_ENV
# Configure conda for bash shell
eval "$(conda shell.bash hook)"
if [[ ! -z ${_CONDA_ENV} ]]
then
# Stack previous conda env which gets cleared after
# `eval "$(conda shell.bash hook)"`
conda activate ${_CONDA_ENV}
unset _CONDA_ENV
fi
if [[ ! -d "${_prefixroot}/env/${_name}/" ]]
then
conda create --prefix "${_prefixroot}/env/${_name}/" --yes --no-default-packages || \
exit_on_error_code "Failed to create ${_name} conda env"
fi
conda activate "${_prefixroot}/env/${_name}/" && \
exit_on_error_code "Failed to activate ${_name} conda env"
"$@"
}
function init_venv {
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--name) local _name="$1"; shift
echo "name = [${_name}]"
;;
--prefix) local _prefixroot="$1"; shift
echo "prefix = [${_prefixroot}]"
;;
--tmp) local _prefixroot="$1"; shift
>&2 echo "Deprecated --tmp option. Use --prefix instead."
echo "tmp = [${_prefixroot}]"
;;
--) break ;;
-h | --help | *)
if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
then
>&2 echo "Unknown option [${_arg}]"
fi
>&2 echo "Options for ${FUNCNAME[0]} are:"
>&2 echo "--name STR venv prefix name"
>&2 echo "--prefix DIR directory to hold the virtualenv prefix"
exit 1
;;
esac
done
if [[ ! -d "${_prefixroot}/venv/${_name}/" ]]
then
mkdir -p "${_prefixroot}/venv/${_name}/" && \
python3 -m venv "${_prefixroot}/venv/${_name}/" || \
exit_on_error_code "Failed to create ${_name} venv"
fi
source "${_prefixroot}/venv/${_name}/bin/activate" || \
exit_on_error_code "Failed to activate ${_name} venv"
python3 -m pip install --upgrade pip
"$@"
}
function print_annex_checksum {
local _CHECKSUM=MD5
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
-c | --checksum) local _CHECKSUM="$1"; shift ;;
-h | --help)
>&2 echo "Options for $(basename "$0") are:"
>&2 echo "[-c | --checksum CHECKSUM] checksum to print (default: MD5)"
exit 1
;;
--) break ;;
*) >&2 echo "Unknown option [${_arg}]"; exit 3 ;;
esac
done
for _file in "$@"
do
local _annex_file=`ls -l -- "${_file}" | grep -o ".git/annex/objects/.*/${_CHECKSUM}.*"`
if [[ ! -f "${_annex_file}" ]]
then
continue
fi
local _checksum=`echo "${_annex_file}" | xargs basename`
local _checksum=${_checksum##*--}
echo "${_checksum%%.*} ${_file}"
done
}
function list {
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
-d | --dataset) local _DATASET="$1"; shift ;;
-h | --help)
>&2 echo "Options for $(basename "$0") are:"
>&2 echo "[-d | --dataset PATH] dataset location"
git-annex list --help >&2
exit 1
;;
--) break ;;
*) >&2 echo "Unknown option [${_arg}]"; exit 3 ;;
esac
done
if [[ ! -z "${_DATASET}" ]]
then
pushd "${_DATASET}" >/dev/null || exit 1
fi
git-annex list "$@" | { grep -o " .*" | grep -Eo "[^ ]+.*" || test $? = 1 ; }
if [[ ! -z "${_DATASET}" ]]
then
popd >/dev/null
fi
}
function subdatasets {
local _VAR=0
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--var) local _VAR=1 ;;
-h | --help)
>&2 echo "Options for $(basename "$0") are:"
>&2 echo "--var also list datasets variants"
>&2 echo "then following --"
datalad subdatasets --help
exit 1
;;
--) break ;;
*) >&2 echo "Unknown option [${_arg}]"; exit 3 ;;
esac
done
if [[ ${_VAR} != 0 ]]
then
datalad subdatasets $@ | grep -o ": .* (dataset)" | grep -o " .* " | grep -o "[^ ]*" | \
while read subds
do
echo ${subds}
for _d in "${subds}.var"/*
do
if [[ -d "$_d" ]]
then
echo $_d
fi
done
done
else
datalad subdatasets $@ | grep -o ": .* (dataset)" | grep -o " .* " | grep -o "[^ ]*"
fi
}
function unshare_mount {
if [[ ${EUID} -ne 0 ]]
then
unshare -rm ./"${BASH_SOURCE[0]}" unshare_mount "$@" <&0
exit $?
fi
if [[ -z ${_SRC} ]]
then
local _SRC=${PWD}
fi
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--src) local _SRC="$1"; shift
echo "src = [${_SRC}]"
;;
--dir) local _DIR="$1"; shift
echo "dir = [${_DIR}]"
;;
--cd) local _CD=1
echo "cd = [${_CD}]"
;;
--) break ;;
-h | --help | *)
if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
then
>&2 echo "Unknown option [${_arg}]"
fi
>&2 echo "Options for $(basename "$0") are:"
>&2 echo "[--dir DIR] mount location"
>&2 echo "[--src DIR] source dir (optional)"
exit 1
;;
esac
done
mkdir -p ${_SRC}
mkdir -p ${_DIR}
local _SRC=$(cd "${_SRC}" && pwd -P)
local _DIR=$(cd "${_DIR}" && pwd -P)
mount -o bind ${_SRC} ${_DIR}
exit_on_error_code "Could not mount directory"
if [[ ! ${_CD} -eq 0 ]]
then
cd ${_DIR}
fi
unshare -U ${SHELL} -s "$@" <&0
}
function jug_exec {
if [[ -z ${_jug_exec} ]]
then
local _jug_exec=${_SCRIPT_DIR}/jug_exec.py
fi
local _jug_argv=()
while [[ $# -gt 0 ]]
do
local _arg="$1"; shift
case "${_arg}" in
--script | -s) local _jug_exec="$1"; shift ;;
-h | --help)
>&2 echo "Options for ${FUNCNAME[0]} are:"
>&2 echo "[--script | -s JUG_EXEC] path to the jug wrapper script (default: '${_jug_exec}')"
${_jug_exec} --help
exit
;;
--) break ;;
*) _jug_argv+=("${_arg}") ;;
esac
done
# Remove trailing '/' in argv before sending to jug
jug execute "${_jug_argv[@]%/}" ${_jug_exec} -- "${@%/}"
}
# function unshare_mount {
# if [[ ${EUID} -ne 0 ]]
# then
# unshare -rm ./"${BASH_SOURCE[0]}" unshare_mount "$@" <&0
# exit $?
# fi
#
# if [[ -z ${_SRC} ]]
# then
# local _SRC=${PWD}
# fi
# if [[ -z ${_DIR} ]]
# then
# local _DIR=${_PWD}
# fi
# while [[ $# -gt 0 ]]
# do
# local _arg="$1"; shift
# case "${_arg}" in
# --src) local _SRC="$1"; shift
# echo "src = [${_SRC}]"
# ;;
# --upper) local _UPPER="$1"; shift
# echo "upper = [${_UPPER}]"
# ;;
# --dir) local _DIR="$1"; shift
# echo "dir = [${_DIR}]"
# ;;
# --wd) local _WD="$1"; shift
# echo "wd = [${_WD}]"
# ;;
# --cd) local _CD=1
# echo "cd = [${_CD}]"
# ;;
# --) break ;;
# -h | --help | *)
# if [[ "${_arg}" != "-h" ]] && [[ "${_arg}" != "--help" ]]
# then
# >&2 echo "Unknown option [${_arg}]"
# fi
# >&2 echo "Options for $(basename "$0") are:"
# >&2 echo "[--upper DIR] upper mount overlay"
# >&2 echo "[--wd DIR] overlay working directory"
# >&2 echo "[--src DIR] lower mount overlay (optional)"
# >&2 echo "[--dir DIR] mount location (optional)"
# exit 1
# ;;
# esac
# done
#
# mkdir -p ${_SRC}
# mkdir -p ${_UPPER}
# mkdir -p ${_WD}
# mkdir -p ${_DIR}
#
# local _SRC=$(cd "${_SRC}" && pwd -P) || echo "${_SRC}"
# local _UPPER=$(cd "${_UPPER}" && pwd -P)
# local _WD=$(cd "${_WD}" && pwd -P)
# local _DIR=$(cd "${_DIR}" && pwd -P)
#
# mount -t overlay overlay -o lowerdir="${_SRC}",upperdir="${_UPPER}",workdir="${_WD}" "${_DIR}"
# exit_on_error_code "Could not mount overlay"
#
# if [[ ! ${_CD} -eq 0 ]]
# then
# cd ${_DIR}
# fi
#
# unshare -U ${SHELL} -s "$@" <&0
# }
if [[ ! -z "$@" ]]
then
"$@"
fi
|